/***************************************************************************
                          voodoo.h  -  description
                             -------------------
    begin                : Wed Aug 21 2002
    copyright            : (C) 2002 by John Clemens
    email                : john@deater.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#define PCI_VENDOR_TDFX 0x121a
#define TDFX_VOODOO     0x0001
#define TDFX_VOODOO2    0x0002
#define TDFX_BANSHEE    0x0003
#define TDFX_VELOCITY   0x0004
#define TDFX_VOODOO3    0x0005
#define TDFX_VOODOO5    0x0009


struct card_list_info {
      int dev_id;
      char name[50];
      int subvendor_id;
      int subvendor_card;
      int default_gfx_clock;
      int default_mem_clock;
};
/*
struct card_list_info card_list[] = {
      { 0x0001, "3Dfx Voodoo",  0,  0,  0,  0 },
      { 0x0002, "3Dfx Voodoo 2",  0,  0,  0,  0 },
      { 0x0003, "3Dfx Voodoo Banshee AGP",  0x121a, 0x0001, 0,  0 },
      { 0x0003, "3Dfx Voodoo Banshee AGP SGRAM", 0x121a,  0x0003, 0,  0 },
      { 0x0003, "3Dfx Voodoo Banshee",  0x121a, 0x0004, 0,  0 },
      { 0x0004, "3Dfx Voodoo Banshee [Velocity 100]", 0,  0,  124,  124 },
      { 0x0005, "3Dfx Voodoo3", 0,  0,  0,  0 },
      { 0x0005, "3Dfx Voodoo3 3500 TV (NTSC)", 0x121a,  0x0060, 183,  183 },
      { 0x0005, "3Dfx Voodoo3 3500 TV (PAL)", 0x121a,  0x0061, 183,  183 },
      { 0x0005, "3Dfx Voodoo3 3500 TV (SECAM)", 0x121a,  0x0062, 183,  183 },
      { 0x0009, "3Dfx Voodoo4/5", 0,  0,  0,  0 },
      { 0,  "", 0,  0,  0,  0 }
};
*/
struct voodoo_info {
      struct voodoo_info *next;
      char *name;
      int pci_dev_id;
      int memory_size;
      int default_gfx_speed;
      int default_memory_speed;
      int gfx_speed;
      int memory_speed;
      int tv_out;
      int mmio_addr;
      int *mmio;
};

struct voodoo_info * voodoo_probe(void);
int voodoo_cleanup(struct voodoo_info *v);
int voodoo_set_gfx_speed(struct voodoo_info *v, int speed);
int voodoo_get_gfx_speed(struct voodoo_info *v);
int voodoo_set_mem_speed(struct voodoo_info *v, int speed);
int voodoo_get_mem_speed(struct voodoo_info *v);
